Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# GT2005StableSelfLocatorSample Class Reference

The class represents a sample. More...

`#include <GT2005StableSelfLocatorSample.h>`

Inheritance diagram for GT2005StableSelfLocatorSample:

[legend]
Collaboration diagram for GT2005StableSelfLocatorSample:

[legend]
List of all members.

## Public Types
enum | { UNINITIALIZED_PROBABILITY = 2, NO_PERCEPT_PROBABILITY = 3, PERCEPT_TTL_MS = 2000 }
enum | PerceptType { xFieldLine, yFieldLine, border, flag, yellowGoal, skyblueGoal, lineCrossing, numberOfPerceptTypes }
## Public Member Functions
| GT2005StableSelfLocatorSample ()
| Constructor.
| GT2005StableSelfLocatorSample (const Pose2D &pose)
| Constructor.
double | getProbability () const
void | updateProbability ()
void | updateProbability (const double *average)
void | setPerceptProbability (GT2005StableSelfLocatorSample::PerceptType type, double value)
| sets the probability for a percept.
bool | isValid () const
## Public Attributes
Pose2D | camera
| Temporary representing the pose of the camera.
double | perceptProbabilities [numberOfPerceptTypes]
| a probability for each percept-type recognized
long | perceptTimestamps [numberOfPerceptTypes]
GT2005StableSelfLocatorSample * | next
| The next sample in the cell cube.
## Static Public Attributes
double | paramProbUpLimit
double | paramProbDownLimit
double | paramProbDelay

## Detailed Description

The class represents a sample.

Definition at line 16 of file GT2005StableSelfLocatorSample.h.

## Member Enumeration Documentation

anonymous enum

  | Enumeration values:
  UNINITIALIZED_PROBABILITY |
  NO_PERCEPT_PROBABILITY |
  PERCEPT_TTL_MS |
Definition at line 20 of file GT2005StableSelfLocatorSample.h.

enum GT2005StableSelfLocatorSample::PerceptType

  | Enumeration values:
  xFieldLine |
  yFieldLine |
  border |
  flag |
  yellowGoal |
  skyblueGoal |
  lineCrossing |
  numberOfPerceptTypes | the number of percept types
Definition at line 32 of file GT2005StableSelfLocatorSample.h.

## Constructor & Destructor Documentation

GT2005StableSelfLocatorSample::GT2005StableSelfLocatorSample | ( |  | ) |

| Constructor. Definition at line 12 of file GT2005StableSelfLocatorSample.cpp.

GT2005StableSelfLocatorSample::GT2005StableSelfLocatorSample | ( | const Pose2D & | pose | ) |

  | Constructor. Parameters:
  pose | The pose of the sample.
Definition at line 23 of file GT2005StableSelfLocatorSample.cpp. References SystemCall::getCurrentSystemTime().

Here is the call graph for this function:

## Member Function Documentation

double GT2005StableSelfLocatorSample::getProbability | ( |  | ) | const`[inline]`

| Definition at line 60 of file GT2005StableSelfLocatorSample.h. Referenced by GT2005StableSelfLocator::calcPoseFromSubCube(), and GT2005StableSelfLocator::resample().

void GT2005StableSelfLocatorSample::updateProbability | ( |  | ) |

| Definition at line 40 of file GT2005StableSelfLocatorSample.cpp.

void GT2005StableSelfLocatorSample::updateProbability | ( | const double * | average | ) |

| Definition at line 62 of file GT2005StableSelfLocatorSample.cpp. References max, NO_PERCEPT_PROBABILITY, paramProbDelay, and paramProbUpLimit.

void GT2005StableSelfLocatorSample::setPerceptProbability | ( | GT2005StableSelfLocatorSample::PerceptType | type,
|  | double | value
| ) |

  | sets the probability for a percept. replaces setProbability in GT04SL limits change of probability to +paramProbUpLimit and -paramProbDownLimit differs from gt code by strange part dependent on goal type Parameters:
  type | of the percept the probability is updated for
Returns: value the probability for the percept Definition at line 93 of file GT2005StableSelfLocatorSample.cpp. References paramProbDownLimit, and paramProbUpLimit. Referenced by GT2005StableSelfLocator::updateByCenterCircle(), GT2005StableSelfLocator::updateByCrossing(), GT2005StableSelfLocator::updateByFlag(), GT2005StableSelfLocator::updateByGoalPost(), and GT2005StableSelfLocator::updateByPoint().

bool GT2005StableSelfLocatorSample::isValid | ( |  | ) | const`[inline]`

| Definition at line 84 of file GT2005StableSelfLocatorSample.h. Referenced by GT2005StableSelfLocator::calcPose(), and GT2005StableSelfLocator::calcPoseFromSubCube().

## Member Data Documentation

double GT2005StableSelfLocatorSample::paramProbUpLimit`[static]`

| Initial value:
     0.01
           GT2005StableSelfLocatorSample::paramProbDownLimit = 0.005
           GT2005StableSelfLocatorSample::paramProbDelay = 3
Definition at line 8 of file GT2005StableSelfLocatorSample.cpp. Referenced by setPerceptProbability(), and updateProbability().

double GT2005StableSelfLocatorSample::paramProbDownLimit`[static]`

| Definition at line 26 of file GT2005StableSelfLocatorSample.h. Referenced by setPerceptProbability().

double GT2005StableSelfLocatorSample::paramProbDelay`[static]`

| Definition at line 26 of file GT2005StableSelfLocatorSample.h. Referenced by updateProbability().

Pose2D GT2005StableSelfLocatorSample::camera

| Temporary representing the pose of the camera. Definition at line 44 of file GT2005StableSelfLocatorSample.h. Referenced by GT2005StableSelfLocator::motionUpdate(), GT2005StableSelfLocator::updateByFlag(), and GT2005StableSelfLocator::updateByGoalPost().

double GT2005StableSelfLocatorSample::perceptProbabilities[numberOfPerceptTypes]

| a probability for each percept-type recognized Definition at line 45 of file GT2005StableSelfLocatorSample.h. Referenced by GT2005StableSelfLocator::calcAveragePerceptTypeProbabilities().

long GT2005StableSelfLocatorSample::perceptTimestamps[numberOfPerceptTypes]

| Definition at line 46 of file GT2005StableSelfLocatorSample.h.

GT2005StableSelfLocatorSample* GT2005StableSelfLocatorSample::next

| The next sample in the cell cube. Definition at line 47 of file GT2005StableSelfLocatorSample.h. Referenced by GT2005StableSelfLocator::calcPose(), and GT2005StableSelfLocator::calcPoseFromSubCube().

The documentation for this class was generated from the following files:

- Modules/SelfLocator/GT2005StableSelfLocator/GT2005StableSelfLocatorSample.h
- Modules/SelfLocator/GT2005StableSelfLocator/GT2005StableSelfLocatorSample.cpp